/*
 * Copyright (c) 2010-2011, The MiCode Open Source Community (www.micode.net)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package net.micode.notes.gtask.data;

import android.database.Cursor;
import android.text.TextUtils;
import android.util.Log;

import net.micode.notes.data.Notes;
import net.micode.notes.data.Notes.DataColumns;
import net.micode.notes.data.Notes.DataConstants;
import net.micode.notes.data.Notes.NoteColumns;
import net.micode.notes.gtask.exception.ActionFailureException;
import net.micode.notes.tool.GTaskStringUtils;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;


public class Task extends Node {
    private static final String TAG = Task.class.getSimpleName();

    private boolean mCompleted;

    private String mNotes;

    private JSONObject mMetaInfo;

    private Task mPriorSibling;

    private TaskList mParent;

    public Task() {
        super();
        mCompleted = false;
        mNotes = null;
        mPriorSibling = null;
        mParent = null;
        mMetaInfo = null;
    }
/*这是一个名为Task的Java类，它继承自Node类。Task类有以下成员变量：
mCompleted：表示任务是否已完成，类型为布尔值。
mNotes：表示任务的笔记，类型为字符串。
mMetaInfo：表示任务的元信息，类型为JSONObject对象。
mPriorSibling：表示前一个同级任务，类型为Task对象。
mParent：表示任务所属的任务列表，类型为TaskList对象。
Task类还有一个无参数构造函数，它会将mCompleted、mNotes、、mPriorSiblingmParent和mMetaInfo都初始化为null或false。
继承自Node类的成员变量和方法没有在这个代码片段中给出，但是可以推测出Node类是一个表示树节点的基类，TaskList类是一个表示任务列表的类。在Task类中，mPriorSibling和mParent成员变量用于表示任务在任务列表中的位置，mMetaInfo成员变量用于存储一些其他的任务信息。*/
    public JSONObject getCreateAction(int actionId) {
        JSONObject js = new JSONObject();
/*该方法返回一个JSONObject对象，用于表示创建一个动作的操作。
该方法有一个整数类型的参数actionId，用于指定要创建的动作的ID。
方法主体中，首先创建一个空的JSONObject对象js。
然后，会往该对象中添加一个表示要执行的操作类型的键值对，该键值对的键为"type"，值为"action"。
接着，会添加一个表示要创建的动作ID的键值对，该键值对的键为"action_id"，值为actionId参数的值。
最后，将js对象返回。*/
        try {
            // action_type
            js.put(GTaskStringUtils.GTASK_JSON_ACTION_TYPE,
                    GTaskStringUtils.GTASK_JSON_ACTION_TYPE_CREATE);

            // action_id
            js.put(GTaskStringUtils.GTASK_JSON_ACTION_ID, actionId);

            // index
            js.put(GTaskStringUtils.GTASK_JSON_INDEX, mParent.getChildTaskIndex(this));

            // entity_delta
            JSONObject entity = new JSONObject();
            entity.put(GTaskStringUtils.GTASK_JSON_NAME, getName());
            entity.put(GTaskStringUtils.GTASK_JSON_CREATOR_ID, "null");
            entity.put(GTaskStringUtils.GTASK_JSON_ENTITY_TYPE,
                    GTaskStringUtils.GTASK_JSON_TYPE_TASK);
            /*在上述代码中，getCreateAction方法中的JSONObject js对象被初始化之后，首先向其中添加一个表示操作类型的键值对，该键值对的键为GTaskStringUtils.GTASK_JSON_ACTION_TYPE，值为GTaskStringUtils.GTASK_JSON_ACTION_TYPE_CREATE。
            接着，会添加一个表示要创建的动作ID的键值对，该键值对的键为GTaskStringUtils.GTASK_JSON_ACTION_ID，值为actionId参数的值。
            然后，会添加一个表示任务在任务列表中的位置的键值对，该键值对的键为GTaskStringUtils.GTASK_JSON_INDEX，值为当前任务在其父任务列表中的位置，通过调用mParent.getChildTaskIndex(this)方法获得。
            最后，会添加一个表示任务实体的键值对，该键值对的键为"entity_delta"，值为一个新的JSONObject对象entity。entity对象中包含三个键值对，分别为任务名称、创建者ID和任务类型。
            其中，任务名称通过getName()方法获取，创建者ID为"null"，任务类型为GTaskStringUtils.GTASK_JSON_TYPE_TASK。
            最终，js对象中包含了所有要创建动作所需的信息，并将其返回。*/
            if (getNotes() != null) {
                entity.put(GTaskStringUtils.GTASK_JSON_NOTES, getNotes());
            }
            js.put(GTaskStringUtils.GTASK_JSON_ENTITY_DELTA, entity);

            // parent_id
            js.put(GTaskStringUtils.GTASK_JSON_PARENT_ID, mParent.getGid());

            // dest_parent_type
            js.put(GTaskStringUtils.GTASK_JSON_DEST_PARENT_TYPE,
                    GTaskStringUtils.GTASK_JSON_TYPE_GROUP);

            // list_id
            js.put(GTaskStringUtils.GTASK_JSON_LIST_ID, mParent.getGid());
            /*在上述代码中，如果当前任务存在笔记，则会向entity对象中添加一个表示笔记内容的键值对，该键值对的键为GTaskStringUtils.GTASK_JSON_NOTES，值为当前任务的笔记内容，通过调用getNotes()方法获取。然后，将entity对象添加为js对象的一个子对象，键为GTaskStringUtils.GTASK_JSON_ENTITY_DELTA。
            接着，会添加一个表示当前任务所属的任务列表ID的键值对，该键值对的键为GTaskStringUtils.GTASK_JSON_PARENT_ID，值为当前任务所属任务列表的GID，通过调用mParent.getGid()方法获取。
            然后，会添加一个表示当前任务所属的任务列表类型的键值对，该键值对的键为GTaskStringUtils.GTASK_JSON_DEST_PARENT_TYPE，值为GTaskStringUtils.GTASK_JSON_TYPE_GROUP，表示当前任务所属的任务列表是一个组。
            最后，会添加一个表示当前任务所属的任务列表ID的键值对，该键值对的键为GTaskStringUtils.GTASK_JSON_LIST_ID，值为当前任务所属任务列表的GID。
            最终，js对象中包含了所有创建动作所需的信息，并将其返回。*/
            // prior_sibling_id
            if (mPriorSibling != null) {
                js.put(GTaskStringUtils.GTASK_JSON_PRIOR_SIBLING_ID, mPriorSibling.getGid());
            }

        } catch (JSONException e) {
            Log.e(TAG, e.toString());
            e.printStackTrace();
            throw new ActionFailureException("fail to generate task-create jsonobject");
        }

        return js;
    }/*添加一个表示当前任务的前一个兄弟任务ID的键值对。
    如果当前任务的前一个兄弟任务不为空，则会向 js 对象中添加一个表示前一个兄弟任务ID的键值对，该键值对的键为 GTaskStringUtils.GTASK_JSON_PRIOR_SIBLING_ID，值为前一个兄弟任务的 GID，通过调用 mPriorSibling.getGid() 方法获取。
    这个键值对表示当前任务是前一个兄弟任务的下一个兄弟任务，也就是将当前任务插入到前一个兄弟任务后面。如果添加键值对时出现 JSONException 异常，则会打印异常信息，并抛出 ActionFailureException 异常。
    最后，返回表示创建任务的动作的 JSONObject 对象。*/

    public JSONObject getUpdateAction(int actionId) {
        JSONObject js = new JSONObject();

        try {
            // 将 action_type 字段设置为 GTaskStringUtils.GTASK_JSON_ACTION_TYPE_UPDATE
            js.put(GTaskStringUtils.GTASK_JSON_ACTION_TYPE,
                    GTaskStringUtils.GTASK_JSON_ACTION_TYPE_UPDATE);

            // 将 action_id 字段设置为传入的 actionId 参数
            js.put(GTaskStringUtils.GTASK_JSON_ACTION_ID, actionId);

            // 将 id 字段设置为当前任务的 GID
            js.put(GTaskStringUtils.GTASK_JSON_ID, getGid());

            // 将 entity_delta 字段设置为一个 JSONObject 对象，
            // 该对象表示要更新的任务的属性和值
            JSONObject entity = new JSONObject();
            entity.put(GTaskStringUtils.GTASK_JSON_NAME, getName()); // 任务名称
            if (getNotes() != null) { // 如果任务的注释不为空，则添加注释字段
                entity.put(GTaskStringUtils.GTASK_JSON_NOTES, getNotes());
            }
            entity.put(GTaskStringUtils.GTASK_JSON_DELETED, getDeleted()); // 任务是否被删除
            js.put(GTaskStringUtils.GTASK_JSON_ENTITY_DELTA, entity);

        } catch (JSONException e) {
            // 如果出现 JSONException 异常，则打印异常信息，并抛出 ActionFailureException 异常
            Log.e(TAG, e.toString());
            e.printStackTrace();
            throw new ActionFailureException("fail to generate task-update jsonobject");
        }

        // 返回表示更新任务的动作的 JSONObject 对象
        return js;
    }

    public void setContentByRemoteJSON(JSONObject js) {
        if (js != null) {
            try {
                // 解析 id 字段，将其设置为本地任务对象的 GID
                if (js.has(GTaskStringUtils.GTASK_JSON_ID)) {
                    setGid(js.getString(GTaskStringUtils.GTASK_JSON_ID));
                }

                // 解析 last_modified 字段，将其设置为本地任务对象的最后修改时间
                if (js.has(GTaskStringUtils.GTASK_JSON_LAST_MODIFIED)) {
                    setLastModified(js.getLong(GTaskStringUtils.GTASK_JSON_LAST_MODIFIED));
                }

                // 解析 name 字段，将其设置为本地任务对象的名称
                if (js.has(GTaskStringUtils.GTASK_JSON_NAME)) {
                    setName(js.getString(GTaskStringUtils.GTASK_JSON_NAME));
                }

                // 解析 notes 字段，将其设置为本地任务对象的注释
                if (js.has(GTaskStringUtils.GTASK_JSON_NOTES)) {
                    setNotes(js.getString(GTaskStringUtils.GTASK_JSON_NOTES));
                }

                // 解析 deleted 字段，将其设置为本地任务对象的删除状态
                if (js.has(GTaskStringUtils.GTASK_JSON_DELETED)) {
                    setDeleted(js.getBoolean(GTaskStringUtils.GTASK_JSON_DELETED));
                }

                // 解析 completed 字段，将其设置为本地任务对象的完成状态
                if (js.has(GTaskStringUtils.GTASK_JSON_COMPLETED)) {
                    setCompleted(js.getBoolean(GTaskStringUtils.GTASK_JSON_COMPLETED));
                }
            } catch (JSONException e) {
                Log.e(TAG, e.toString());
                e.printStackTrace();
                throw new ActionFailureException("fail to get task content from jsonobject");
            }
        }
    }

    public void setContentByLocalJSON(JSONObject js) {
        if (js == null || !js.has(GTaskStringUtils.META_HEAD_NOTE)
                || !js.has(GTaskStringUtils.META_HEAD_DATA)) {
            Log.w(TAG, "setContentByLocalJSON: nothing is avaiable");
        }

        try {
            // 解析任务的注释信息
            JSONObject note = js.getJSONObject(GTaskStringUtils.META_HEAD_NOTE);

            // 解析任务的数据信息
            JSONArray dataArray = js.getJSONArray(GTaskStringUtils.META_HEAD_DATA);

            // 检查任务的类型是否为 Notes.TYPE_NOTE
            if (note.getInt(NoteColumns.TYPE) != Notes.TYPE_NOTE) {
                Log.e(TAG, "invalid type");
                return;
            }

            // 解析任务的名称
            for (int i = 0; i < dataArray.length(); i++) {
                JSONObject data = dataArray.getJSONObject(i);
                if (TextUtils.equals(data.getString(DataColumns.MIME_TYPE), DataConstants.NOTE)) {
                    setName(data.getString(DataColumns.CONTENT));
                    break;
                }
            }

        } catch (JSONException e) {
            Log.e(TAG, e.toString());
            e.printStackTrace();
        }
    }

    public JSONObject getLocalJSONFromContent() {
        String name = getName();

        try {
            if (mMetaInfo == null) {
                // 如果当前任务对象没有元信息，则表示该任务是从 Web 创建的
                if (name == null) {
                    Log.w(TAG, "the note seems to be an empty one");
                    return null;
                }

                // 创建一个新的 JSONObject，并将任务的名称添加到其中
                JSONObject js = new JSONObject();
                JSONObject note = new JSONObject();
                JSONArray dataArray = new JSONArray();
                JSONObject data = new JSONObject();
                data.put(DataColumns.CONTENT, name);
                dataArray.put(data);
                js.put(GTaskStringUtils.META_HEAD_DATA, dataArray);
                note.put(NoteColumns.TYPE, Notes.TYPE_NOTE);
                js.put(GTaskStringUtils.META_HEAD_NOTE, note);
                return js;
            } else {
                // 如果当前任务对象有元信息，则表示该任务是同步过来的
                JSONObject note = mMetaInfo.getJSONObject(GTaskStringUtils.META_HEAD_NOTE);
                JSONArray dataArray = mMetaInfo.getJSONArray(GTaskStringUtils.META_HEAD_DATA);

                // 遍历任务的数据信息，找到 MIME_TYPE 为 DataConstants.NOTE 的 JSONObject，并将其 CONTENT 字段设置为任务的名称
                for (int i = 0; i < dataArray.length(); i++) {
                    JSONObject data = dataArray.getJSONObject(i);
                    if (TextUtils.equals(data.getString(DataColumns.MIME_TYPE), DataConstants.NOTE)) {
                        data.put(DataColumns.CONTENT, getName());
                        break;
                    }
                }

                // 将任务的类型设置为 Notes.TYPE_NOTE，并返回元信息对象
                note.put(NoteColumns.TYPE, Notes.TYPE_NOTE);
                return mMetaInfo;
            }
        } catch (JSONException e) {
            Log.e(TAG, e.toString());
            e.printStackTrace();
            return null;
        }
    }


    public void setMetaInfo(MetaData metaData) {
        if (metaData != null && metaData.getNotes() != null) {
            try {
                // 将元数据对象的 notes 字段转换为 JSONObject 对象，并存储在当前对象的 mMetaInfo 变量中
                mMetaInfo = new JSONObject(metaData.getNotes());
            } catch (JSONException e) {
                Log.w(TAG, e.toString());
                mMetaInfo = null;
            }
        }
    }

    public int getSyncAction(Cursor c) {
        try {
            JSONObject noteInfo = null;
            // 从 mMetaInfo 变量中获取笔记的元数据信息
            if (mMetaInfo != null && mMetaInfo.has(GTaskStringUtils.META_HEAD_NOTE)) {
                noteInfo = mMetaInfo.getJSONObject(GTaskStringUtils.META_HEAD_NOTE);
            }

            if (noteInfo == null) {
                // 如果笔记的元数据信息不存在，则需要更新远程数据
                Log.w(TAG, "it seems that note meta has been deleted");
                return SYNC_ACTION_UPDATE_REMOTE;
            }

            if (!noteInfo.has(NoteColumns.ID)) {
                // 如果笔记的元数据信息中没有 ID 字段，则需要更新本地数据
                Log.w(TAG, "remote note id seems to be deleted");
                return SYNC_ACTION_UPDATE_LOCAL;
            }

            // 检查笔记的 ID 是否匹配
            if (c.getLong(SqlNote.ID_COLUMN) != noteInfo.getLong(NoteColumns.ID)) {
                Log.w(TAG, "note id doesn't match");
                return SYNC_ACTION_UPDATE_LOCAL;
            }

            if (c.getInt(SqlNote.LOCAL_MODIFIED_COLUMN) == 0) {
                // 如果本地没有修改笔记，则比较修改时间来判断是否需要更新数据
                if (c.getLong(SqlNote.SYNC_ID_COLUMN) == getLastModified()) {
                    // 本地和远程都没有修改，无需同步
                    return SYNC_ACTION_NONE;
                } else {
                    // 将远程数据应用到本地
                    return SYNC_ACTION_UPDATE_LOCAL;
                }
            } else {
                // 如果本地有修改笔记，则需要比较修改时间和 GTask ID 来判断同步操作
                if (!c.getString(SqlNote.GTASK_ID_COLUMN).equals(getGid())) {
                    Log.e(TAG, "gtask id doesn't match");
                    return SYNC_ACTION_ERROR;
                }
                if (c.getLong(SqlNote.SYNC_ID_COLUMN) == getLastModified()) {
                    // 只有本地有修改，将本地数据更新到远程
                    return SYNC_ACTION_UPDATE_REMOTE;
                } else {
                    // 本地和远程都有修改，需要解决冲突
                    return SYNC_ACTION_UPDATE_CONFLICT;
                }
            }
        } catch (Exception e) {
            Log.e(TAG, e.toString());
            e.printStackTrace();
        }

        return SYNC_ACTION_ERROR;
    }

    public boolean isWorthSaving() {
        // 判断对象是否值得保存
        return mMetaInfo != null // 如果 mMetaInfo 不为空
                || (getName() != null && getName().trim().length() > 0) // 或者 name 不为空且去除空格后长度大于 0
                || (getNotes() != null && getNotes().trim().length() > 0); // 或者 notes 不为空且去除空格后长度大于 0
    }

    public void setCompleted(boolean completed) {
        // 设置对象的 mCompleted 变量为给定的布尔值
        this.mCompleted = completed;
    }

    public void setNotes(String notes) {
        // 设置对象的 mNotes 变量为给定的字符串
        this.mNotes = notes;
    }

    public void setPriorSibling(Task priorSibling) {
        // 设置对象的 mPriorSibling 变量为给定的 Task 对象
        this.mPriorSibling = priorSibling;
    }

    public void setParent(TaskList parent) {
        // 设置对象的 mParent 变量为给定的 TaskList 对象
        this.mParent = parent;
    }

    public boolean getCompleted() {
        // 返回对象的 mCompleted 变量
        return this.mCompleted;
    }

    public String getNotes() {
        // 返回对象的 mNotes 变量
        return this.mNotes;
    }

    public Task getPriorSibling() {
        // 返回对象的 mPriorSibling 变量，其中 mPriorSibling 是一个 Task 对象
        return this.mPriorSibling;
    }

    public TaskList getParent() {
        // 返回对象的 mParent 变量，其中 mParent 是一个 TaskList 对象
        return this.mParent;
    }

}
